from cpl_discord.service import DiscordBotServiceABC
from cpl_query.extension import List
from discord import Guild

from bot_graphql.abc.query_abc import QueryABC


class GuildQuery(QueryABC):
    def __init__(
        self,
        bot: DiscordBotServiceABC,
    ):
        QueryABC.__init__(self, "Guild")

        self._bot = bot

        self.set_field("id", lambda g, *_: g.id)
        self.set_field("name", lambda g, *_: g.name)
        self.set_field("channels", self._resolve_channels)
        self.set_field("roles", lambda g, *_: g.roles)
        self.set_field("emojis", lambda g, *_: g.emojis)

    def _resolve_channels(self, g: Guild, *_, filter=None):
        users = List(any).extend(g.channels)

        if filter is None:
            return users

        if "id" in filter:
            users = users.where(lambda c: c.id == int(filter["id"]))

        if "name" in filter:
            users = users.where(lambda c: c.id == filter["name"])

        if "type" in filter:
            users = users.where(lambda c: type(c).__name__ == filter["type"])

        return users
