from cpl_core.logging import LoggerABC
from cpl_discord.events import OnReadyABC

from bot_core.configuration.feature_flags_enum import FeatureFlagsEnum
from bot_core.configuration.feature_flags_settings import FeatureFlagsSettings
from bot_data.model.technician_config import TechnicianConfig
from modules.permission.abc.permission_service_abc import PermissionServiceABC


class PermissionOnReadyEvent(OnReadyABC):
    def __init__(self, logger: LoggerABC, permission_service: PermissionServiceABC, tech_config: TechnicianConfig):
        OnReadyABC.__init__(self)
        self._logger = logger
        self._permission_service = permission_service
        self._tech_config = tech_config

    async def on_ready(self):
        if not FeatureFlagsSettings.get_flag_from_dict(
            self._tech_config.feature_flags, FeatureFlagsEnum.permission_module
        ):
            return
        self._permission_service.on_ready()
